

////////// draw the first two hierarchy   ///////////
void reset()
{
  for (int i=0; i<sectC.length; i++) 
    sectC[i].createSegments();  

  sect.createSegments();
}

////////  draw the second and third hierarchy     /////////////////////////////
void chooseDivison(int a)
{
  for (int i=0; i<sectC[a].children.size(); i++)
    sectC[a].children.get(i).createSegments();

  sectC[a].createSegments();
}

///////////////// draw dewey sections /////////////////////////////////
//void chooseSection(int a)
//{
//  sectD[a].createSegments();
//}


///////////////   mouse over to see the data   /////////////////////////////////////
void mouseover()
{
  float ang, dist;
  ang= atan2((mouseY-centery), (mouseX-centerx));
  if (ang<0) ang = ang + TWO_PI;
  dist = sqrt((mouseX-centerx)*(mouseX-centerx)+(mouseY-centery)*(mouseY-centery));

  stroke(250);
  textSize(12); 
  textAlign(LEFT, CENTER);
  if (dist < 400)
  {

    /////////////////   when in overview mode ///////////////////////////////////////////
    if (set == false)
    {
      for (int i=0; i< sectC.length-1; i++)
      {
        for (int j=0; j< sectC[i].children.size(); j++)
        {
          if (sectC[i].rstart*TWO_PI< ang && sectC[i+1].rstart*TWO_PI> ang)
          {
            if (dist> 0.75*radius && dist <(0.75+sectC[i].rextent*9)*radius)
            {
              text("Dewey class "+sectC[i].label, mouseX+3, mouseY+3);
              text("Average title length: "+sectC[i].value, mouseX+15, mouseY+15);
            } else if (dist >(0.75+sectC[i].rextent*9)*radius && dist < (0.75+sectC[i].rextent*9+sectC[i].children.get(j).rextent*9)*radius)
            {
              if ((sectC[i].children.get(j).rstart*sectC[i].rextent+sectC[i].rstart)*TWO_PI<ang && ang<(sectC[i].rstart+(sectC[i].children.get(j).rextent+sectC[i].children.get(j).rstart)*sectC[i].rextent)*TWO_PI )
              {
                text("Dewey division "+sectC[i].children.get(j).label, mouseX+3, mouseY+3);
                text("Average title length: "+sectC[i].children.get(j).value, mouseX+15, mouseY+15);
              }
            }
          } else if (sectC[9].rstart*TWO_PI < ang)
          {
            if (dist> 0.75*radius && dist <(0.75+sectC[9].rextent*9)*radius)
            {
              text("Dewey class "+sectC[9].label, mouseX+3, mouseY+3);
              text("Average title length: "+sectC[9].value, mouseX+15, mouseY+15);
            } else if (dist >(0.75+sectC[9].rextent*9)*radius && dist < (0.75+sectC[9].rextent*9+sectC[9].children.get(j).rextent*9)*radius)
            {
              if ((sectC[9].children.get(j).rstart*sectC[9].rextent+sectC[9].rstart)*TWO_PI<ang && ang<(sectC[9].rstart+(sectC[9].children.get(j).rextent+sectC[9].children.get(j).rstart)*sectC[9].rextent)*TWO_PI )
              {
                text("Dewey division "+sectC[9].children.get(j).label, mouseX+3, mouseY+3);
                text("Average title length: "+sectC[9].children.get(j).value, mouseX+15, mouseY+15);
              }
            }
          }
        }
      }
    }


    /////// /////////////     in different dewey classes  //////////////////////////////////
    if (set== true && changeD<10)
    {
      int b = changeD;
      for (int i=0; i<9; i++)
      {
        for (int j=0; j< sectD[b*10+i].children.size(); j++)
        {
          if (sectD[b*10+i].rstart*TWO_PI< ang && sectD[b*10+i+1].rstart*TWO_PI> ang)
          {
            if (dist> 0.75*radius && dist <(0.75+sectD[b*10+i].rextent*6)*radius)
            {
              text("Dewey class "+sectD[b*10+i].label, mouseX+3, mouseY+3);
              text("Average title length: "+sectD[b*10+i].value, mouseX+15, mouseY+15);
            } else if (dist >(0.75+sectD[b*10+i].rextent*6)*radius && dist < (0.75+sectD[b*10+i].rextent*6+sectD[b*10+i].children.get(j).rextent*6)*radius)
            {
              if ((sectD[b*10+i].children.get(j).rstart*sectD[b*10+i].rextent+sectD[b*10+i].rstart)*TWO_PI<ang && ang<(sectD[b*10+i].rstart+(sectD[b*10+i].children.get(j).rextent+sectD[b*10+i].children.get(j).rstart)*sectD[b*10+i].rextent)*TWO_PI )
              {
                text("Dewey division "+sectD[b*10+i].children.get(j).label, mouseX+3, mouseY+3);
                text("Average title length: "+sectD[b*10+i].children.get(j).value, mouseX+15, mouseY+15);
              }
            }
          } else if (sectD[b*10+9].rstart*TWO_PI < ang)
          {
            for (int k=0; k<sectD[b*10+9].children.size(); k++)
            {
              if (dist> 0.75*radius && dist <(0.75+sectD[b*10+9].rextent*6)*radius)
              {
                text("Dewey class "+sectD[b*10+9].label, mouseX+3, mouseY+3);
                text("Average title length: "+sectD[b*10+9].value, mouseX+15, mouseY+15);
              } else if (dist >(0.75+sectD[b*10+9].rextent*6)*radius && dist < (0.75+sectD[b*10+9].rextent*6+sectD[b*10+9].children.get(k).rextent*6)*radius)
              {
                if ((sectD[b*10+9].children.get(k).rstart*sectD[b*10+9].rextent+sectD[b*10+9].rstart)*TWO_PI<ang && ang<(sectD[b*10+9].rstart+(sectD[b*10+9].children.get(k).rextent+sectD[b*10+9].children.get(k).rstart)*sectD[b*10+9].rextent)*TWO_PI )
                {
                  text("Dewey division "+sectD[b*10+9].children.get(k).label, mouseX+3, mouseY+3);
                  text("Average title length: "+sectD[b*10+9].children.get(k).value, mouseX+15, mouseY+15);
                }
              }
            }
          }
        }
      }
    }
  }
}